// Raw OS interface module -*- C++ -*-

// Copyright (C) 1997-1999 Cygnus Solutions
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING.  If not, write to the Free
// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.

// As a special exception, you may use this file as part of a free software
// library without restriction.  Specifically, if other files instantiate
// templates or use macros or inline functions from this file, or you compile
// this file and link it with other files to produce an executable, this
// file does not by itself cause the resulting executable to be covered by
// the GNU General Public License.  This exception does not however
// invalidate any other reasons why the executable file might be covered by
// the GNU General Public License.

#include <bits/std_ios.h> //ios_base and _IO_FILE

namespace std {

  // Make sure this matches what is typedef'd in std_fstream.h. Could
  // just include std_fstream.h and typedef to filebuf::file_type, but
  // that's even more of a pain just to get one line. . .
  typedef _IO_FILE file_type;

  file_type* _S_os_open(const char* __name, ios_base::openmode __mode);

  int _S_os_close(file_type* __file);

  size_t 
  _S_os_read(void* __p, size_t __size, size_t __nmem, file_type* __file);

  size_t 
  _S_os_write(void* __p, size_t __size, size_t __nmem, file_type* __file);

  int _S_os_seek(file_type* __file, long __off, int __where);

} // namespace std




